function [X, load]= NS_fact( mat, yy, lambda)

% this function computes the Nelson and Siegel factors
% and loadings

% Source: "Does real-time macroeconomic information help to predict interest rates?" 
% by Alberto Caruso and Laura Coroneo, Journal of Money, Credit and
% Banking, Forthcoming

% Contact Author: Laura Coroneo
% e-mail address: laura.coroneo@york.ac.uk
% Release date: 24/10/22


load_lev    = ones(1,size(mat,2));
load_slope  = (1-exp(-lambda*mat))./(lambda*mat);
load_curv   = (1-exp(-lambda*mat))./(lambda*mat)-exp(-lambda*mat);

load         = [load_lev' load_slope' load_curv'];

X = yy/load'; 